//
//  DataLayer.h
//  ColorsWar
//
/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

#define kMPosition @"mapPosition"
#define kMColor @"mapColor"
#define kMBackGround @"mapBackground"
#define kMRadius @"mapRadius"
#define kMPercent @"mapTransformPercent"
#define kMType @"mapType"

#import <GameKit/GameKit.h>
#import <Foundation/Foundation.h>
#import "cocos2d.h"

typedef enum {
	kStateStartGame,
	kStatePicker,
	kStateMultiplayer,
	kStateMultiplayerCointoss,
	kStateMultiplayerReconnect
} gameStates;

typedef enum {
	NETWORK_ACK,					// no packet
	NETWORK_COINTOSS,				// decide who is going to be the server
	NETWORK_INIT_DATA,				// send init data
	NETWORK_STREAM_DATA,			// send dynamic data
	NETWORK_HEARTBEAT
} packetCodes;

@interface DataLayer : CCLayer<GKPeerPickerControllerDelegate, GKSessionDelegate, UIAlertViewDelegate> {
	NSMutableArray *allMapPoints;
	CGRect mycolorfortest;
	int gameMode;
	CGSize mapSize;
	float length;
	int kills,deathes;
	
	//networking
	NSInteger	gameState;

	GKSession		*gameSession;
	int				gameUniqueID;
	int				gamePacketNumber;
	NSString		*gamePeerId;
	NSDate			*lastHeartbeatDate;
	
	UIAlertView		*connectionAlert;
}
@property (nonatomic,retain) NSMutableArray* allMapPoints;
@property (nonatomic,readwrite) CGRect mycolorfortest;
@property (nonatomic,readwrite) int gameMode;
@property (nonatomic,readwrite) CGSize mapSize;
@property (nonatomic,readwrite) float length;
@property (nonatomic,readwrite) int kills,deathes;

@property (nonatomic, retain) GKSession	 *gameSession;
@property (nonatomic, copy)	 NSString	 *gamePeerId;
@property (nonatomic, retain) NSDate		 *lastHeartbeatDate;
@property (nonatomic, retain) UIAlertView *connectionAlert;
@property (nonatomic,readwrite) NSInteger		gameState;
@property (nonatomic,readwrite) int gameUniqueID;

+(DataLayer*)sharedDataLayer;
-(void)addPointAt:(CGPoint)p Color:(CGRect)c BColor:(CGRect)bc Radius:(float)r Type:(int)t;
-(BOOL)removePointAt:(int)index;
-(void)removeAllMapPoints;
-(void)addKDToDOTA;
-(void)addMapPointsToDOTA;
-(void)addMapPointsFromDOTA;
-(NSString*)hintAtIndex:(int)i;

-(void)startPicker;
-(void)invalidateSession:(GKSession *)session;
- (void)sendNetworkPacket:(GKSession *)session packetID:(int)packetID withData:(void *)data ofLength:(int)length reliable:(BOOL)howtosend;

@end
