//
//  MainMenu.m
//  ColorsWar
//
/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */
#import "ApostleBasis.h"
#import "MainMenu.h"
#import "GameController.h"
#import "DataLayer.h"
#import "DataOfTheAncients.h"
#import "CWColor.h"

@interface MainMenu (Private)

-(void)getFromDOTA;
-(void)refreshDOTA;
-(void)addMainMenu;
-(void)addRecordView;
-(void)addSettingMenu;
-(void)addCharacterDrawMenu;
-(void)addColorChoosingMenu;
-(void)addShipImages;
@end


@implementation MainMenu

-(void)dealloc{
	[super dealloc];
}
+(id) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	DataLayer *dl = [DataLayer node];
	DataOfTheAncients *dota = [DataOfTheAncients node];
	[scene addChild:dl];
	[scene addChild:dota];
	
	// 'layer' is an autorelease object.
	MainMenu *layer = [MainMenu node];
	// add layer as a child to scene
	[scene addChild: layer];
	// return the scene
	return scene;
}

-(void)getFromDOTA{
	DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
	ApostleBasis *m = dota.theship;	
	
	CGPoint c = ccp(screenSize.width*9/5,screenSize.height*23/16);
	float hr = screenSize.height*9/32;
	CCHex = CenterCalculate(c,hr,(m.visualDistance-240)/120,(m.drawSpeed-4)/13);
	
	[cv.pointsOfShape removeAllObjects];
	[cv.pointsOfShape addObjectsFromArray:m.theShape];
	cv.theColor = m.selfcolor;
	colorChosed = m.selfcolor;	
	
}

-(void)refreshDOTA{
	DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
	ApostleBasis *m = dota.theship;
	
	m.theShape = [NSArray arrayWithArray:cv.pointsOfShape];
	m.selfcolor = colorChosed;

	CGPoint c = ccp(screenSize.width*9/5,screenSize.height*23/16);
	float r = screenSize.height*9/32;
	m.visualDistance = distanceWithCode(c, CCHex, r, 0)*120+240;
	m.drawSpeed = distanceWithCode(c, CCHex, r, 1)*13+4;
	m.healDistance = distanceWithCode(c, CCHex, r, 2)*20+10;
	m.soulSpeed = distanceWithCode(c, CCHex, r, 3)*200+100;
	m.attackDistance = distanceWithCode(c, CCHex, r, 4)*400+400;
	m.currentEnergy = m.maxEnergy = distanceWithCode(c, CCHex, r, 5)*4000+2000;
	
}

-(void)addMainMenu
{
	CCMenuItem *up = [CCMenuItemFont itemFromString:@"Design" target:self selector:@selector(goup:)];
	CCMenuItem *down = [CCMenuItemFont itemFromString:@"Records" target:self selector:@selector(gobuttom:)];
	CCMenuItem *left = [CCMenuItemFont itemFromString:@"Survival" target:self selector:@selector(shootenemies:)];
	CCMenuItem *right = [CCMenuItemFont itemFromString:@"Awake" target:self selector:@selector(exploremode:)];
	
	CCMenuItem *mp1 = [CCMenuItemFont itemFromString:@"VS Mode" target:self selector:@selector(vsMode:)];
	CCMenuItem *mp2 = [CCMenuItemFont itemFromString:@" " target:self selector:@selector(gameCenter:)];
	
	CCMenu *vm = [CCMenu menuWithItems:mp1,mp2,nil];
	vm.position = ccp(screenSize.width*0.55,screenSize.height*0.65);
	[vm alignItemsHorizontallyWithPadding:screenSize.width*0.7];
	[self addChild:vm];
	
	CCMenu *mud = [CCMenu menuWithItems:up,down,nil];
	mud.position = ccp(screenSize.width/2,screenSize.height/2);
	[mud alignItemsVerticallyWithPadding:screenSize.height*2/3];

	CCMenu *mlr = [CCMenu menuWithItems:left,right,nil];
	mlr.position = ccp(screenSize.width/2,screenSize.height*0.35);
	[mlr alignItemsHorizontallyWithPadding:screenSize.width/2];

	[self addChild:mud];
	[self addChild:mlr];
}

-(void)addRecordView{
	reinfo = [RecordInfo node];
	reinfo.position = ccp(screenSize.width/2,-screenSize.height/2);
	[self addChild:reinfo];

	CCMenuItem *back = [CCMenuItemFont itemFromString:@"Back" target:self selector:@selector(goback:)];
	CCMenuItem *seeall = [CCMenuItemFont itemFromString:@"See Stars" target:self selector:@selector(AchievementMode:)];
	
	CCMenu *spmenu = [CCMenu menuWithItems:back,seeall,nil];
	spmenu.position = ccp(screenSize.width/2,-screenSize.height/2);
	[spmenu alignItemsVerticallyWithPadding:screenSize.height*13/16];
	[self addChild:spmenu];
}

-(void)addSettingMenu
{
	CCMenuItem *help = [CCMenuItemFont itemFromString:@"Hint" target:self selector:@selector(showHelpInfo:)];
	CCMenuItem *back = [CCMenuItemFont itemFromString:@"Back" target:self selector:@selector(goback:)];
	CCMenuItem *chooseColor = [CCMenuItemFont itemFromString:@"Set Status" target:self selector:@selector(goright:)];
	CCMenuItem *chooseCharacter = [CCMenuItemFont itemFromString:@"Build Mode" target:self selector:@selector(goleft:)];
	
	CCMenu *spmenu = [CCMenu menuWithItems:help,back,nil];
	spmenu.position = ccp(screenSize.width/2,screenSize.height*1.5);
	[spmenu alignItemsVerticallyWithPadding:screenSize.height*0.8];
	
	CCMenu *choose = [CCMenu menuWithItems:chooseCharacter,chooseColor,nil];
	choose.position = ccp(screenSize.width/2,screenSize.height*7/6);
	[choose alignItemsHorizontallyWithPadding:screenSize.width/2];
	
	[self addChild:spmenu];
	[self addChild:choose];	
	
	CCLabelTTF *la1 = [CCLabelTTF labelWithString:@"Missile" fontName:@"Verdana" fontSize:screenSize.height/26];
	CCLabelTTF *la2 = [CCLabelTTF labelWithString:@"Laser" fontName:@"Verdana" fontSize:screenSize.height/26];
	CCLabelTTF *la3 = [CCLabelTTF labelWithString:@"Regenerate" fontName:@"Verdana" fontSize:screenSize.height/26];
	CCLabelTTF *la4 = [CCLabelTTF labelWithString:@"Blink" fontName:@"Verdana" fontSize:screenSize.height/26];
	CCLabelTTF *la5 = [CCLabelTTF labelWithString:@"Heat Sword" fontName:@"Verdana" fontSize:screenSize.height/26];
	CCLabelTTF *la6 = [CCLabelTTF labelWithString:@"Shield" fontName:@"Verdana" fontSize:screenSize.height/26];
	
	float dy = screenSize.height/6;
	
	la1.position = ccp(screenSize.width*0.1,dy*10);
	la2.position = ccp(screenSize.width*0.1,dy*9);
	la3.position = ccp(screenSize.width*0.1,dy*8);
	la4.position = ccp(screenSize.width*0.9,dy*10);
	la5.position = ccp(screenSize.width*0.9,dy*9);
	la6.position = ccp(screenSize.width*0.9,dy*8);
	
	[self addChild:la1];
	[self addChild:la2];
	[self addChild:la3];
	[self addChild:la4];
	[self addChild:la5];
	[self addChild:la6];
	
	helpinfo = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/24];
	helpinfo.position = ccp(screenSize.width/2,screenSize.height*1.85);
	[self addChild:helpinfo];
}

-(IBAction)showHelpInfo:(id)sender{
	[helpinfo setString:[[DataLayer sharedDataLayer] hintAtIndex:hindex]];
	 hindex++;
}

-(void)addCharacterDrawMenu
{
	cv = [CharacterView node];
	cv.position = ccp(-screenSize.width/2,screenSize.height*3/2);
	cv.scale = screenSize.height*0.8/100;
	cv.theColor = colorChosed;
	cv.backcolor = background;
	[self addChild:cv];
	
	informationOfCv = [CCLabelTTF labelWithString:@"(X,Y), C" fontName:@"Verdana" fontSize:screenSize.height/25];
	informationOfCv.position = ccp(-screenSize.width/2,screenSize.height*3/2);
	[self addChild:informationOfCv];
	
	CCMenuItem *back = [CCMenuItemFont itemFromString:@"Back" target:self selector:@selector(goback2:)];
	CCMenu *spmenu = [CCMenu menuWithItems:back,nil];
	spmenu.position = ccp(-screenSize.width/10,screenSize.height*3/2);
	[self addChild:spmenu];
	
	CCMenuItem *xa = [CCMenuItemFont itemFromString:@"X++" target:cv selector:@selector(xadd:)];
	CCMenuItem *xs = [CCMenuItemFont itemFromString:@"X--" target:cv selector:@selector(xsub:)];
	CCMenuItem *ya = [CCMenuItemFont itemFromString:@"Y++" target:cv selector:@selector(yadd:)];
	CCMenuItem *ys = [CCMenuItemFont itemFromString:@"Y--" target:cv selector:@selector(ysub:)];
	CCMenuItem *rota = [CCMenuItemFont itemFromString:@"Rotate" target:cv selector:@selector(rotate:)];
    CCMenuItem *new = [CCMenuItemFont itemFromString:@"NEW" target:cv selector:@selector(addnew:)];
	CCMenuItem *de = [CCMenuItemFont itemFromString:@"DEL" target:cv selector:@selector(deletes:)];
	CCMenu *mn = [CCMenu menuWithItems:xa,xs,ya,ys,rota,new,de,nil];
	[mn alignItemsVerticallyWithPadding:screenSize.height/45];
	mn.position = ccp(-screenSize.width*9/10,screenSize.height*3/2);
	[self addChild:mn];
}

-(void)addShipImages
{
	DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
	ApostleBasis *m = dota.theship;
	m.position = ccp(screenSize.width/2,screenSize.height*1.5);
	m.scale = screenSize.width*0.18/100;
	[m becomeActiveShow];
	[self addChild:m];
	[self getFromDOTA];
	
	float spx1 = screenSize.width/5;
	float spy1 = screenSize.height/6;
	sp1 = ccp(spx1,spy1*10);
	sp2 = ccp(spx1,spy1*9);
	sp3 = ccp(spx1,spy1*8);
	sp4 = ccp(spx1*4,spy1*10);
	sp5 = ccp(spx1*4,spy1*9);
	sp6 = ccp(spx1*4,spy1*8);
}

-(void)addColorChoosingMenu
{
	colorChosed = CGRectMake(CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1(), 1);
	background = WhiteWithAlpha(0.5);
	float start,end,deltay;
	start = screenSize.width/5;
	end = screenSize.width*3/5;
	deltay = screenSize.height*3/40;
	CGPoint spos = ccp(screenSize.width,screenSize.height);
	DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
	ApostleBasis *m = dota.theship;
	shinfo = [ShipInfo node];
	shinfo.position = ccp(screenSize.width*1.5,screenSize.height*66/40);
	[self addChild:shinfo];
	[shinfo showInfoOf:m];
	
	CCHex = ccpAdd(ccp(screenSize.width*4/5,screenSize.height*7/16),spos);
	float hr = screenSize.height*9/32;
	CCHex = CenterCalculate(CCHex,hr,(m.visualDistance-300)/200,(m.drawSpeed-2)/7);
	
	Rs = ccpAdd(ccp(start,deltay*4),spos);
	Re = ccpAdd(ccp(end,deltay*4),spos);
	Gs = ccpAdd(ccp(start,deltay*3),spos);
	Ge = ccpAdd(ccp(end,deltay*3),spos);
	Bs = ccpAdd(ccp(start,deltay*2),spos);
	Be = ccpAdd(ccp(end,deltay*2),spos);
	As = ccpAdd(ccp(start,deltay),spos);
	Ae = ccpAdd(ccp(end,deltay),spos);
	
	CCMenuItem *back = [CCMenuItemFont itemFromString:@"Back" target:self selector:@selector(goback2:)];
	CCMenu *b = [CCMenu menuWithItems:back,nil];
	b.position = ccpAdd(ccp(start/2,deltay*6), spos);
	[self addChild:b];
		
	CCLabelTTF *la1 = [CCLabelTTF labelWithString:@"HP" fontName:@"Verdana" fontSize:screenSize.height/20];
	CCLabelTTF *la2 = [CCLabelTTF labelWithString:@"Regen" fontName:@"Verdana" fontSize:screenSize.height/20];
	CCLabelTTF *la3 = [CCLabelTTF labelWithString:@"Sight" fontName:@"Verdana" fontSize:screenSize.height/20];
	CCLabelTTF *la4 = [CCLabelTTF labelWithString:@"Blink Range" fontName:@"Verdana" fontSize:screenSize.height/20];
	CCLabelTTF *la5 = [CCLabelTTF labelWithString:@"Attack Range" fontName:@"Verdana" fontSize:screenSize.height/20];
	CCLabelTTF *la6 = [CCLabelTTF labelWithString:@"Laser Number" fontName:@"Verdana" fontSize:screenSize.height/20];
	
	float dy = screenSize.height/14;

	la1.position = ccp(screenSize.width*1.3,deltay*22+dy*2.5);
	la2.position = ccp(screenSize.width*1.3,deltay*22+dy*1.5);
	la3.position = ccp(screenSize.width*1.3,deltay*22+dy*0.5);
	la4.position = ccp(screenSize.width*1.3,deltay*22-dy*0.5);
	la5.position = ccp(screenSize.width*1.3,deltay*22-dy*1.5);
	la6.position = ccp(screenSize.width*1.3,deltay*22-dy*2.5);
	
	[self addChild:la1];
	[self addChild:la2];
	[self addChild:la3];
	[self addChild:la4];
	[self addChild:la5];
	[self addChild:la6];
	
	CCMenuItem *changec = [CCMenuItemFont itemFromString:@"Color" target:self selector:@selector(changeShipColor:)];
	CCMenu *c = [CCMenu menuWithItems:changec,nil];
	c.position = ccp(screenSize.width*1.3,deltay*22-dy*3.8);
	[self addChild:c];
}

-(IBAction)changeShipColor:(id)sender{
	colorChosed = CGRectMake(CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1());
	[self refreshDOTA];
}

void drawBar( CGPoint s, CGPoint e, float width, float percent, CGRect startColor , CGRect endColor)
{
	float length = (e.x-s.x)*percent;
	ccVertex2F vertices[4] = {
		{s.x,s.y+width/2},
		{s.x,s.y-width/2},
		{s.x+length,e.y+width/2},
		{s.x+length,e.y-width/2},
	};
	CGRect mixed;
	if(percent==0)
		mixed = endColor;
	else 
		mixed = CGRectMix(startColor, endColor, 1/percent);
		
	ccVertex2F colors[8] = {
		{startColor.origin.x, startColor.origin.y},
		{startColor.size.width, startColor.size.height},
		{startColor.origin.x, startColor.origin.y},
		{startColor.size.width, startColor.size.height},
		{mixed.origin.x, mixed.origin.y},
		{mixed.size.width, mixed.size.height},
		{mixed.origin.x, mixed.origin.y},
		{mixed.size.width, mixed.size.height},
	};
	
	// Default GL states: GL_TEXTURE_2D, GL_VERTEX_ARRAY, GL_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY
	// Needed states: GL_VERTEX_ARRAY, 
	// Unneeded states: GL_TEXTURE_2D, GL_TEXTURE_COORD_ARRAY, GL_COLOR_ARRAY	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);		
}

void hexPlus( CGPoint center,float r1, float r2, CGRect color1, CGRect color2, int numofpoint)
{
	const float coef = (float)M_PI*2/numofpoint;
	
	GLfloat *vertices = calloc( sizeof(GLfloat)*2*(numofpoint+1)*2, 1);
	GLfloat *colors = calloc( sizeof(GLfloat)*4*(numofpoint+1)*2, 1);
	if( ! vertices || ! colors)
		return;
	
	vertices[0] = center.x;
	vertices[1] = center.y+r1;
	vertices[2] = center.x;
	vertices[3] = center.y+r2;
	colors[0] = color1.origin.x;
	colors[1] = color1.origin.y;
	colors[2] = color1.size.width;
	colors[3] = color1.size.height;
	colors[4] = color2.origin.x;
	colors[5] = color2.origin.y;
	colors[6] = color2.size.width;
	colors[7] = color2.size.height;
	
	for(NSUInteger i=1;i<(numofpoint+1);i++)
	{
		float rads = i*coef;
		GLfloat ix1 = r1 * sinf(rads) + center.x;
		GLfloat iy1 = r1 * cosf(rads) + center.y;
		GLfloat ix2 = r2 * sinf(rads) + center.x;
		GLfloat iy2 = r2 * cosf(rads) + center.y;
		
		vertices[i*4] = ix1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+1] = iy1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+2] = ix2 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+3] = iy2 * CC_CONTENT_SCALE_FACTOR();
		
		colors[i*8] = color1.origin.x;
		colors[i*8+1] = color1.origin.y;
		colors[i*8+2] = color1.size.width;
		colors[i*8+3] = color1.size.height;
		
		colors[i*8+4] = color2.origin.x;
		colors[i*8+5] = color2.origin.y;
		colors[i*8+6] = color2.size.width;
		colors[i*8+7] = color2.size.height;
	}
	
	// Default GL states: GL_TEXTURE_2D, GL_VERTEX_ARRAY, GL_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY
	// Needed states: GL_VERTEX_ARRAY, 
	// Unneeded states: GL_TEXTURE_2D, GL_TEXTURE_COORD_ARRAY, GL_COLOR_ARRAY	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, (numofpoint+1)*2);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
	
	free( vertices );
	free( colors );
	
}

void abilityHex( CGPoint center,CGPoint apoint,float r ,CGRect color)
{
	GLfloat vertices[16];
	GLfloat colors[32];
	float coef = (float)M_PI/3;
	vertices[0] = apoint.x;
	vertices[1] = apoint.y;
	
	colors[0] = color.origin.x;
	colors[1] = color.origin.y;
	colors[2] = color.size.width;
	colors[3] = color.size.height;
	
	for(int i=1;i<8;i++){
		vertices[2*i] = center.x+r*sinf(i*coef);
		vertices[2*i+1] = center.y+r*cosf(i*coef);
		
		colors[i*4] = 0;
		colors[i*4+1] = 0;
		colors[i*4+2] = 0;
		colors[i*4+3] = 0;
	}
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_FAN, 0, 8);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
	
}

void abilityLine(CGPoint sp,CGPoint ep,CGRect startc,CGRect endc,CGRect edgecolor,float width)
{
	float anglestoe = AngleOfTwoPoints(sp, ep);
	float radfactor = (float)M_PI/180;
	
	GLfloat vertices[12];
	GLfloat colors[24];
	
	float dx1 = width/2*sinf((anglestoe+90)*radfactor);
	float dy1 = width/2*cosf((anglestoe+90)*radfactor);
	float dx2 = width/2*sinf((anglestoe+270)*radfactor);
	float dy2 = width/2*cosf((anglestoe+270)*radfactor);
	
	vertices[0] = sp.x+dx1;
	vertices[1] = sp.y+dy1;
	vertices[2] = ep.x+dx1;
	vertices[3] = ep.y+dy1;
	vertices[4] = sp.x;
	vertices[5] = sp.y;
	vertices[6] = ep.x;
	vertices[7] = ep.y;
	vertices[8] = sp.x+dx2;
	vertices[9] = sp.y+dy2;
	vertices[10] = ep.x+dx2;
	vertices[11] = ep.y+dy2;
	
	colors[0] = colors[4] = colors[16] = colors[20] = edgecolor.origin.x;
	colors[1] = colors[5] = colors[17] = colors[21] = edgecolor.origin.y;
	colors[2] = colors[6] = colors[18] = colors[22] = edgecolor.size.width;
	colors[3] = colors[7] = colors[19] = colors[23] = edgecolor.size.height;
	
	colors[8] = startc.origin.x;
	colors[9] = startc.origin.y;
	colors[10] = startc.size.width;
	colors[11] = startc.size.height;
	
	colors[12] = endc.origin.x;
	colors[13] = endc.origin.y;
	colors[14] = endc.size.width;
	colors[15] = endc.size.height;
	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 6);
	
	// restore default state
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);		
	
}

-(void)draw{
	//Set a timecounter
	counter++;
	if(counter>620)counter=0;
	changingColor = CGRectMake(0.5+0.5*sinf( (float)counter/100 ),0.5+0.5*cosf((float)counter/100),0.5+0.5*sinf((float)counter/200),CCRANDOM_0_1());
	//Draw the Main GLView
	if(CGPointEqualToPoint(self.position, ccp(0,0))){
		hexPlus(ccp(screenSize.width/2,screenSize.height/2),0 ,screenSize.height*2/7*0.97, colorChosed, changingColor,6);
		hexPlus(ccp(screenSize.width/2,screenSize.height/2),screenSize.height*2/7*0.97 ,screenSize.height*2/7, changingColor, BlackWithAlpha(0),6);
		
		float cf = (float)(counter%62)/61;
		float waveradius = cf*screenSize.height*3/7;
		hexPlus(ccp(screenSize.width/2,screenSize.height/2),waveradius-20 ,waveradius, BlackWithAlpha(0),CGRectMultiple(colorChosed, 1-cf), 64);
		hexPlus(ccp(screenSize.width/2,screenSize.height/2),waveradius ,waveradius+5, CGRectMultiple(colorChosed, 1-cf), BlackWithAlpha(0),64);

	}
	//Draw the Port GLView
	if(CGPointEqualToPoint(self.position, ccp(0,-screenSize.height))){		
		float spr = screenSize.height/13;
		hexPlus(sp1, 0, spr,ColorWithCode(0, 0), BlackWithAlpha(0), 6);
		hexPlus(sp2, 0, spr,ColorWithCode(1, 0), BlackWithAlpha(0), 6);
		hexPlus(sp3, 0, spr,ColorWithCode(2, 0), BlackWithAlpha(0), 6);
		hexPlus(sp4, 0, spr,ColorWithCode(3, 0), BlackWithAlpha(0), 6);
		hexPlus(sp5, 0, spr,ColorWithCode(4, 0), BlackWithAlpha(0), 6);
		hexPlus(sp6, 0, spr,ColorWithCode(5, 0), BlackWithAlpha(0), 6);
		
		DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
		ApostleBasis *m = dota.theship;
		if(m.canSee){
			hexPlus(sp1, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(0, 0), 64);
			hexPlus(sp1, spr, spr*1.1,ColorWithCode(0, 0),BlackWithAlpha(0), 64);
		}
		if(m.isDrawing){
			hexPlus(sp2, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(1, 0), 64);
			hexPlus(sp2, spr, spr*1.1,ColorWithCode(1, 0),BlackWithAlpha(0), 64);
		}
		if(m.canBeHealed){
			hexPlus(sp3, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(2, 0), 64);
			hexPlus(sp3, spr, spr*1.1,ColorWithCode(2, 0),BlackWithAlpha(0), 64);
		}
		if(m.soulMove){
			hexPlus(sp4, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(3, 0), 64);
			hexPlus(sp4, spr, spr*1.1,ColorWithCode(3, 0),BlackWithAlpha(0), 64);
		}
		if(m.isAttacking){
			hexPlus(sp5, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(4, 0), 64);
			hexPlus(sp5, spr, spr*1.1,ColorWithCode(4, 0),BlackWithAlpha(0), 64);
		}
		if(m.haveShield){
			hexPlus(sp6, spr*0.9, spr,BlackWithAlpha(0),ColorWithCode(5, 0), 64);
			hexPlus(sp6, spr, spr*1.1,ColorWithCode(5, 0),BlackWithAlpha(0), 64);
		}
		
	}
	//Draw the choosingColor GLView
	if(CGPointEqualToPoint(self.position, ccp(-screenSize.width,-screenSize.height)))
	{
		CGRect r = RedWithAlpha(0);
		CGRect g = GreenWithAlpha(0);
		CGRect b = BlueWithAlpha(0);
		CGRect white = WhiteWithAlpha(1);
		CGRect black = BlackWithAlpha(0);
		
		drawBar(Rs, Re, screenSize.height/36,colorChosed.origin.x, white, r);
		drawBar(Gs, Ge, screenSize.height/36,colorChosed.origin.y, white, g);
		drawBar(Bs, Be, screenSize.height/36,colorChosed.size.width, white, b);
		drawBar(As, Ae, screenSize.height/36,colorChosed.size.height, white, black);
		
		float ra = screenSize.height*9/32;
		CGPoint c = ccp(screenSize.width*9/5,screenSize.height*23/16);
		abilityHex(c, CCHex, ra, colorChosed);
		
		DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
		ApostleBasis *m = dota.theship;
		[shinfo showInfoOf:m];
	}
	//Draw the characterDraw GLView
	if(CGPointEqualToPoint(self.position, ccp(screenSize.width,-screenSize.height))){
		CGPoint shownp = [[cv.pointsOfShape objectAtIndex:cv.chosedPoint] CGPointValue];
		[informationOfCv setString:[NSString stringWithFormat:@"(%d,%d) %d",(int)(shownp.x*10),(int)(shownp.y*10),cv.chosedPoint]];
	}
}

- (id) init
{
	self = [super init];
	if (self)
	{
		counter = 0;
		hindex = 12;
		self.isTouchEnabled = YES;
		screenSize = [[CCDirector sharedDirector] winSize];
		//colorChosed = CGRectMake(CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1(), 1);
		mainpos = ccp(0,0);
		[CCMenuItemFont setFontSize:screenSize.height/18];
		[CCMenuItemFont setFontName:@"Verdana"];
		[self addMainMenu];
		[self addRecordView];
		[self addSettingMenu];
		[self addColorChoosingMenu];
		[self addCharacterDrawMenu];
		[self addShipImages];
				
	}
	
	return self;
}

- (IBAction)goup:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:ccp(self.position.x,self.position.y-screenSize.height)];
	[self runAction:action];
}
- (IBAction)gobuttom:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:ccp(self.position.x,self.position.y+screenSize.height)];
	[self runAction:action];
	[self refreshDOTA];
	[reinfo showRecordInfo];
}
- (IBAction)goleft:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:ccp(self.position.x+screenSize.width,self.position.y)];
	[self runAction:action];
	[self getFromDOTA];
}
- (IBAction)goright:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:ccp(self.position.x-screenSize.width,self.position.y)];
	[self runAction:action];
	[self getFromDOTA];
}
- (IBAction)goback:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:mainpos];
	[self runAction:action];
	[self refreshDOTA];
}
- (IBAction)goback2:(id)sender{
	id action = [CCMoveTo actionWithDuration:0.16 position:ccp(0,-screenSize.height)];
	[self runAction:action];
	[self refreshDOTA];
}
-(IBAction)shootenemies:(id)sender{
	DataLayer *dl = [DataLayer sharedDataLayer];
	dl.mycolorfortest = colorChosed;
    dl.gameMode = GameModeShoot;
	dl.mapSize = CGSizeMake(screenSize.width/10, screenSize.height/10);

	[self changeScene];
}

-(IBAction)exploremode:(id)sender{	
	DataLayer *dlayer = [DataLayer sharedDataLayer];
	dlayer.mycolorfortest = colorChosed;
	dlayer.gameMode = GameModeExplore;
	dlayer.mapSize = CGSizeMake(screenSize.width/10, screenSize.height/10);

	[self changeScene];
}				

-(IBAction)AchievementMode:(id)sender{
	DataLayer *dl = [DataLayer sharedDataLayer];
	dl.mapSize = CGSizeMake(screenSize.width/10, screenSize.height/10);
	dl.mycolorfortest = colorChosed;
	[dl addMapPointsFromDOTA];
	dl.gameMode = GameModeFind;
	
	[self changeScene];
}

-(IBAction)vsMode:(id)sender{
	DataLayer *dlayer = [DataLayer sharedDataLayer];
	dlayer.mycolorfortest = colorChosed;
	dlayer.gameMode = GameModeChallenge;
	dlayer.mapSize = CGSizeMake(10, 10);
	
	[self changeScene];
	[dlayer startPicker];
}

-(IBAction)gameCenter:(id)sender{
}

-(void)changeScene{
	CCScene *sc = [GameController scene];
	[[CCDirector sharedDirector] pushScene:sc];	
}

-(void)ccTouchesBegan:(NSSet*)touches withEvent:(UIEvent*)event
{
	if([touches count]>1){
		if([touches count]==3){
			self.position = ccp(0,0);
			[self refreshDOTA];
		}
		return;
	}
	UITouch *touch = [touches anyObject];
	CGPoint location = [touch locationInView:[touch view]];
	CGPoint convertedLocation = [[CCDirector sharedDirector] convertToGL:location];
	CGPoint reallocation = ccp(convertedLocation.x-self.position.x,convertedLocation.y-self.position.y);
	//in the ship image
	if(CGPointEqualToPoint(self.position, ccp(0,-screenSize.height))){
		float spr = screenSize.height/13;
		DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
		ApostleBasis *m = dota.theship;

		if(ccpDistance(reallocation, sp1)<spr)
			m.canSee = !m.canSee;
		if(ccpDistance(reallocation, sp2)<spr)
			m.isDrawing = !m.isDrawing;
		if(ccpDistance(reallocation, sp3)<spr)
			m.canBeHealed = !m.canBeHealed;
		if(ccpDistance(reallocation, sp4)<spr)
			m.soulMove = !m.soulMove;
		if(ccpDistance(reallocation, sp5)<spr)
			m.isAttacking = !m.isAttacking;
		if(ccpDistance(reallocation, sp6)<spr)
			m.haveShield = !m.haveShield;		
			
	}
	//Touch to change color
	if(CGPointEqualToPoint(self.position, ccp(-screenSize.width,-screenSize.height))){

		/*if(CGRectContainsPoint(CGRectOfBar(Rs, Re, screenSize.height/24), reallocation)){
			colorChosed.origin.x = (reallocation.x-Rs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(Gs, Ge, screenSize.height/24), reallocation)){
			colorChosed.origin.y = (reallocation.x-Gs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(Bs, Be, screenSize.height/24), reallocation)){
			colorChosed.size.width = (reallocation.x-Gs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(As, Ae, screenSize.height/24), reallocation)){
			colorChosed.size.height = (reallocation.x-As.x)/(Re.x-Rs.x);
		}	*/
		CGPoint c = ccp(screenSize.width*9/5,screenSize.height*23/16);
		float r = screenSize.height*9/32;
		if(ccpDistance(c, reallocation)<r*sqrt(3)/2)
			CCHex = reallocation;
		cv.theColor = colorChosed;
		[self refreshDOTA];
	}
	//draw the character's shape;
	if(CGPointEqualToPoint(self.position, ccp(screenSize.width,-screenSize.height))){
		CGRect touchrect = CGRectMake(-screenSize.width/2-screenSize.height/2, screenSize.height, screenSize.height, screenSize.height);
		if(CGRectContainsPoint(touchrect, reallocation)){			
			CGPoint tp = ccpSub(convertedLocation, ccp(screenSize.width/2,screenSize.height/2));
			tp.x = tp.x/(screenSize.height*0.8/2)*50;
			tp.y = tp.y/(screenSize.height*0.8/2)*50;
			
			cv.chosedPoint = [cv thePointNearestTo:tp];
			if(tp.y>=25)
				informationOfCv.position = ccp(reallocation.x,reallocation.y-60);
			else 
				informationOfCv.position = ccp(reallocation.x,reallocation.y+60);

		}
	}
}
-(void)ccTouchesMoved:(NSSet*)touches withEvent:(UIEvent*)event
{
	if([touches count]>1){
		return;
	}
	UITouch *touch = [touches anyObject];
	CGPoint location = [touch locationInView:[touch view]];
	CGPoint convertedLocation = [[CCDirector sharedDirector] convertToGL:location];
	CGPoint reallocation = ccp(convertedLocation.x-self.position.x,convertedLocation.y-self.position.y);
	
	if(CGPointEqualToPoint(self.position, ccp(0,-screenSize.height))){
		DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
		ApostleBasis *m = dota.theship;
		CGPoint center = ccp(screenSize.width/2,screenSize.height*1.5);
		if(ccpDistance(reallocation, center)<screenSize.height/3){
			m.rotation = AngleOfTwoPoints(center, reallocation);
		}
	}
	
	if(CGPointEqualToPoint(self.position, ccp(-screenSize.width,-screenSize.height))){
		
		if(CGRectContainsPoint(CGRectOfBar(Rs, Re, screenSize.height/24), reallocation)){
			colorChosed.origin.x = (reallocation.x-Rs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(Gs, Ge, screenSize.height/24), reallocation)){
			colorChosed.origin.y = (reallocation.x-Gs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(Bs, Be, screenSize.height/24), reallocation)){
			colorChosed.size.width = (reallocation.x-Gs.x)/(Re.x-Rs.x);
		}		
		if(CGRectContainsPoint(CGRectOfBar(As, Ae, screenSize.height/24), reallocation)){
			colorChosed.size.height = (reallocation.x-As.x)/(Re.x-Rs.x);
		}	
		CGPoint c = ccp(screenSize.width*9/5,screenSize.height*23/16);
		float r = screenSize.height*9/32;
		if(ccpDistance(c, reallocation)<r*sqrt(3)/2)
			CCHex = reallocation;
		cv.theColor = colorChosed;
		[self refreshDOTA];
	}
	
	if(CGPointEqualToPoint(self.position, ccp(screenSize.width,-screenSize.height))){
		CGRect touchrect = CGRectMake(-screenSize.width/2-screenSize.height/2, screenSize.height, screenSize.height, screenSize.height);
		if(CGRectContainsPoint(touchrect, reallocation)){
			
			CGPoint tp = ccpSub(convertedLocation, ccp(screenSize.width/2,screenSize.height/2));
			tp.x = tp.x/(screenSize.height*0.8/2)*50;
			tp.y = tp.y/(screenSize.height*0.8/2)*50;
			
			cv.drawBoundary = YES;
			
			[cv changeCurrentPointTo:tp];
			if(tp.y>=25)
				informationOfCv.position = ccp(reallocation.x,reallocation.y-60);
			else 
				informationOfCv.position = ccp(reallocation.x,reallocation.y+60);
		}
	}
	if(CGPointEqualToPoint(self.position, ccp(0,-screenSize.height*2))){
		float barlength = screenSize.width*0.35;
		float xs = screenSize.width*0.55;

		if(reallocation.y<=screenSize.height*2.43 && reallocation.x>=xs && reallocation.x<=xs+barlength){
			if(reallocation.y>screenSize.height*2.35){
				background.origin.x = (reallocation.x-xs)/barlength;
			}
			else if(reallocation.y>screenSize.height*2.27){
				background.origin.y = (reallocation.x-xs)/barlength;
			}
			else if(reallocation.y>screenSize.height*2.19){
				background.size.width = (reallocation.x-xs)/barlength;
			}
			else if(reallocation.y>screenSize.height*2.11){
				background.size.height = (reallocation.x-xs)/barlength;
			}
		}
	}
	
}
-(void)ccTouchesEnded:(NSSet*)touches withEvent:(UIEvent*)event{
	cv.drawBoundary = NO;
	
	if(CGPointEqualToPoint(self.position, ccp(screenSize.width,-screenSize.height))){
		[self refreshDOTA];
	}
	
}
-(void)ccTouchesCancelled:(NSSet*)touches withEvent:(UIEvent*)event{
	cv.drawBoundary = NO;
	if(CGPointEqualToPoint(self.position, ccp(screenSize.width,-screenSize.height))){
		[self refreshDOTA];
	}
	
}

@end
