/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

#import "CCTransition.h"

/** CCTransitionPageTurn transition.
 * A transition which peels back the bottom right hand corner of a scene
 * to transition to the scene beneath it simulating a page turn
 *
 * This uses a 3DAction so it's strongly recommended that depth buffering
 * is turned on in CCDirector using:
 *
 * 	[[CCDirector sharedDirector] setDepthBufferFormat:kCCDepthBuffer16]; 
 *
 * @since v0.8.2
 */
@interface CCTransitionPageTurn : CCTransitionScene
{
	BOOL	back_;
}
/**
 * creates a base transition with duration and incoming scene
 * if back is TRUE then the effect is reversed to appear as if the incoming 
 * scene is being turned from left over the outgoing scene
 */
+(id) transitionWithDuration:(ccTime) t scene:(CCScene*)s backwards:(BOOL) back;

/**
 * creates a base transition with duration and incoming scene
 * if back is TRUE then the effect is reversed to appear as if the incoming 
 * scene is being turned from left over the outgoing scene
 */
-(id) initWithDuration:(ccTime) t scene:(CCScene*)s backwards:(BOOL) back;

-(CCActionInterval*) actionWithSize:(ccGridSize) vector;

@end
