/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

// Only compile this code on iOS. These files should NOT be included on your Mac project.
// But in case they are included, it won't be compiled.
#import <Availability.h>
#ifdef __IPHONE_OS_VERSION_MAX_ALLOWED


#import "ESRenderer.h"

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

@interface ES1Renderer : NSObject <ESRenderer>
{
    // The pixel dimensions of the CAEAGLLayer
    GLint backingWidth_;
    GLint backingHeight_;

	unsigned int	samplesToUse_;
	BOOL			multiSampling_;
	
	unsigned int	depthFormat_;
	unsigned int	pixelFormat_;

	// The OpenGL ES names for the framebuffer and renderbuffer used to render to this view
    GLuint defaultFramebuffer_;
	GLuint colorRenderbuffer_;
	GLuint depthBuffer_;
	
	
	//buffers for MSAA
	GLuint msaaFramebuffer_;
	GLuint msaaColorbuffer_;
	
	EAGLContext *context_;
}

/** EAGLContext */
@property (nonatomic,readonly) EAGLContext* context;

- (BOOL)resizeFromLayer:(CAEAGLLayer *)layer;

@end

#endif // __IPHONE_OS_VERSION_MAX_ALLOWED
